diff --git a/usr.sbin/sdpd/sp.c b/usr.sbin/sdpd/sp.c
index 936988be01..b3eeb8c8b4 100644
--- a/usr.sbin/sdpd/sp.c
+++ b/usr.sbin/sdpd/sp.c
@@ -1,6 +1,3 @@
-/* $NetBSD: sp.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/sp.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * sp.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: sp.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/sp.c,v 1.1 2004/01/20 20:48:26 emax Exp $
+ * $Id: sp.c,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/sp.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/queue.h>
@@ -45,7 +42,7 @@ sp_profile_create_service_class_id_list(
 		uint8_t const *data, uint32_t datalen)
 {
 	static uint16_t	service_classes[] = {
-		SDP_SERVICE_CLASS_SERIAL_PORT
+		SDP_SERVICE_CLASS_SERIAL_PORT	
 	};
 
 	return (common_profile_create_service_class_id_list(
@@ -87,12 +84,12 @@ sp_profile_create_protocol_descriptor_list(
 		uint8_t *buf, uint8_t const * const eob,
 		uint8_t const *data, uint32_t datalen)
 {
-	provider_t const	*provider = (provider_t const *) data;
+	provider_p		provider = (provider_p) data;
 	sdp_sp_profile_p	sp = (sdp_sp_profile_p) provider->data;
 
 	return (rfcomm_profile_create_protocol_descriptor_list(
 			buf, eob,
-			(uint8_t const *) &sp->server_channel, 1));
+			(uint8_t const *) &sp->server_channel, 1)); 
 }
 
 static attr_t	sp_profile_attrs[] = {
@@ -111,16 +108,10 @@ static attr_t	sp_profile_attrs[] = {
 	{ 0, NULL } /* end entry */
 };
 
-static uint16_t sp_profile_uuids[] = {
-	SDP_SERVICE_CLASS_SERIAL_PORT,
-	SDP_UUID_PROTOCOL_L2CAP,
-	SDP_UUID_PROTOCOL_RFCOMM,
-};
-
 profile_t	sp_profile_descriptor = {
-	sp_profile_uuids,
-	sizeof(sp_profile_uuids),
+	SDP_SERVICE_CLASS_SERIAL_PORT,
 	sizeof(sdp_sp_profile_t),
 	common_profile_server_channel_valid,
 	(attr_t const * const) &sp_profile_attrs
 };
+
diff --git a/usr.sbin/sdpd/srr.c b/usr.sbin/sdpd/srr.c
index cc16564493..84d8c9c097 100644
--- a/usr.sbin/sdpd/srr.c
+++ b/usr.sbin/sdpd/srr.c
@@ -1,6 +1,3 @@
-/* $NetBSD: srr.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/srr.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * srr.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: srr.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/srr.c,v 1.2 2005/12/06 17:56:36 emax Exp $
+ * $Id: srr.c,v 1.1 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/srr.c 153176 2005-12-06 17:56:36Z emax $
  */
 
 #include <sys/queue.h>
@@ -58,7 +55,7 @@ server_prepare_service_register_response(server_p srv, int32_t fd)
 
 	profile_t	*profile = NULL;
 	provider_t	*provider = NULL;
-	bdaddr_t const	*bdaddr = NULL;
+	bdaddr_t	*bdaddr = NULL;
 	int32_t		 uuid;
 
 	/*
@@ -76,7 +73,7 @@ server_prepare_service_register_response(server_p srv, int32_t fd)
 	SDP_GET16(uuid, req);
 
 	/* Get BD_ADDR */
-	bdaddr = (bdaddr_t const *) req;
+	bdaddr = (bdaddr_p) req;
 	req += sizeof(*bdaddr);
 
 	/* Lookup profile descriptror */
@@ -97,7 +94,7 @@ server_prepare_service_register_response(server_p srv, int32_t fd)
 
 	SDP_PUT16(0, rsp);
 	SDP_PUT32(provider->handle, rsp);
-
+	
 	/* Set reply size */
 	srv->fdidx[fd].rsp_limit = srv->fdidx[fd].omtu - sizeof(sdp_pdu_t);
 	srv->fdidx[fd].rsp_size = rsp - srv->fdidx[fd].rsp;
@@ -139,3 +136,4 @@ server_send_service_register_response(server_p srv, int32_t fd)
 
 	return ((size < 0)? errno : 0);
 }
+
diff --git a/usr.sbin/sdpd/ssar.c b/usr.sbin/sdpd/ssar.c
index 443f23a65a..3bc17d0ef1 100644
--- a/usr.sbin/sdpd/ssar.c
+++ b/usr.sbin/sdpd/ssar.c
@@ -1,6 +1,3 @@
-/* $NetBSD: ssar.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/ssar.c,v 1.2 2008/05/19 10:19:49 corecode Exp $ */
-
 /*
  * ssar.c
  *
@@ -28,12 +25,11 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: ssar.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/ssar.c,v 1.2 2005/01/05 18:37:37 emax Exp $
+ * $Id: ssar.c,v 1.4 2004/01/12 22:54:31 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/ssar.c 139721 2005-01-05 18:37:37Z emax $
  */
 
 #include <sys/queue.h>
-#include <sys/select.h>
 #include <bluetooth.h>
 #include <sdp.h>
 #include <string.h>
@@ -42,6 +38,11 @@
 #include "server.h"
 #include "uuid-private.h"
 
+/* from sar.c */
+int32_t server_prepare_attr_list(provider_p const provider,
+		uint8_t const *req, uint8_t const * const req_end,
+		uint8_t *rsp, uint8_t const * const rsp_end);
+
 /*
  * Prepare SDP Service Search Attribute Response
  */
@@ -52,13 +53,14 @@ server_prepare_service_search_attribute_response(server_p srv, int32_t fd)
 	uint8_t const	*req = srv->req + sizeof(sdp_pdu_t);
 	uint8_t const	*req_end = req + ((sdp_pdu_p)(srv->req))->len;
 	uint8_t		*rsp = srv->fdidx[fd].rsp;
-	uint8_t const	*rsp_end = rsp + L2CAP_MTU_MAXIMUM;
+	uint8_t const	*rsp_end = rsp + NG_L2CAP_MTU_MAXIMUM;
 
-	uint8_t const	*aidptr = NULL;
+	uint8_t const	*sspptr = NULL, *aidptr = NULL;
+	uint8_t		*ptr = NULL;
 
 	provider_t	*provider = NULL;
-	int32_t		 type, rsp_limit, ucount, aidlen, cslen, cs;
-	uint128_t	 ulist[12];
+	int32_t		 type, rsp_limit, ssplen, aidlen, cslen, cs;
+	uint128_t	 uuid, puuid;
 
 	/*
 	 * Minimal Service Search Attribute Request request
@@ -71,11 +73,31 @@ server_prepare_service_search_attribute_response(server_p srv, int32_t fd)
 	 * value8		- 1 byte  ContinuationState
 	 */
 
-	/* Get ServiceSearchPattern */
-	ucount = server_get_service_search_pattern(&req, req_end, ulist);
-	if (ucount < 1 || ucount > 12)
+	if (req_end - req < 13)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
+	/* Get size of ServiceSearchPattern */
+	ssplen = 0;
+	SDP_GET8(type, req);
+	switch (type) {
+	case SDP_DATA_SEQ8:
+		SDP_GET8(ssplen, req);
+		break;
+
+	case SDP_DATA_SEQ16:
+		SDP_GET16(ssplen, req);
+		break;
+
+	case SDP_DATA_SEQ32:
+		SDP_GET32(ssplen, req);
+		break;
+	}
+	if (ssplen <= 0)
+		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
+	sspptr = req;
+	req += ssplen;
+
 	/* Get MaximumAttributeByteCount */
 	if (req + 2 > req_end)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
@@ -123,12 +145,13 @@ server_prepare_service_search_attribute_response(server_p srv, int32_t fd)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
 	SDP_GET8(cslen, req);
-	if (cslen == 2 && req + 2 == req_end)
+	if (cslen != 0) {
+		if (cslen != 2 || req_end - req != 2)
+			return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
 		SDP_GET16(cs, req);
-	else if (cslen == 0 && req == req_end)
+	} else
 		cs = 0;
-	else
-		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
 	/* Process the request. First, check continuation state */
 	if (srv->fdidx[fd].rsp_cs != cs)
@@ -145,23 +168,70 @@ server_prepare_service_search_attribute_response(server_p srv, int32_t fd)
 	 *	[ attr list ]
 	 */
 
-	rsp += 3;	/* leave space for sequence header */
-
-	for (provider = provider_get_first();
-	     provider != NULL;
-	     provider = provider_get_next(provider)) {
-		if (!provider_match_bdaddr(provider, &srv->req_sa.bt_bdaddr))
-			continue;
-
-		if (!provider_match_uuid(provider, ulist, ucount))
-			continue;
-
-		cs = server_prepare_attr_list(provider,
-			aidptr, aidptr + aidlen, rsp, rsp_end);
-		if (cs < 0)
-			return (SDP_ERROR_CODE_INSUFFICIENT_RESOURCES);
-
-		rsp += cs;
+	ptr = rsp + 3;
+
+	while (ssplen > 0) {
+		SDP_GET8(type, sspptr);
+		ssplen --;
+
+		switch (type) {
+		case SDP_DATA_UUID16:
+			if (ssplen < 2)
+				return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
+			memcpy(&uuid, &uuid_base, sizeof(uuid));
+			uuid.b[2] = *sspptr ++;
+			uuid.b[3] = *sspptr ++;
+			ssplen -= 2;
+			break;
+
+		case SDP_DATA_UUID32:
+			if (ssplen < 4)
+				return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
+			memcpy(&uuid, &uuid_base, sizeof(uuid));
+			uuid.b[0] = *sspptr ++;
+			uuid.b[1] = *sspptr ++;
+			uuid.b[2] = *sspptr ++;
+			uuid.b[3] = *sspptr ++;
+			ssplen -= 4;
+			break;
+
+		case SDP_DATA_UUID128:
+			if (ssplen < 16)
+				return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
+			memcpy(uuid.b, sspptr, 16);
+			sspptr += 16;	
+			ssplen -= 16; 
+			break;
+
+		default:
+			return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+			/* NOT REACHED */
+		}
+
+		for (provider = provider_get_first();
+		     provider != NULL;
+		     provider = provider_get_next(provider)) {
+			if (!provider_match_bdaddr(provider, &srv->req_sa.l2cap_bdaddr))
+				continue;
+
+			memcpy(&puuid, &uuid_base, sizeof(puuid));
+			puuid.b[2] = provider->profile->uuid >> 8;
+			puuid.b[3] = provider->profile->uuid;
+
+			if (memcmp(&uuid, &puuid, sizeof(uuid)) != 0 &&
+			    memcmp(&uuid, &uuid_public_browse_group, sizeof(uuid)) != 0)
+				continue;
+
+			cs = server_prepare_attr_list(provider,
+				aidptr, aidptr + aidlen, ptr, rsp_end);
+			if (cs < 0)
+				return (SDP_ERROR_CODE_INSUFFICIENT_RESOURCES);
+
+			ptr += cs;
+		}
 	}
 
 	/* Set reply size (not counting PDU header and continuation state) */
@@ -169,13 +239,14 @@ server_prepare_service_search_attribute_response(server_p srv, int32_t fd)
 	if (srv->fdidx[fd].rsp_limit > rsp_limit)
 		srv->fdidx[fd].rsp_limit = rsp_limit;
 
-	srv->fdidx[fd].rsp_size = rsp - srv->fdidx[fd].rsp;
+	srv->fdidx[fd].rsp_size = ptr - rsp;
 	srv->fdidx[fd].rsp_cs = 0;
 
 	/* Fix AttributeLists sequence header */
-	rsp = srv->fdidx[fd].rsp;
-	SDP_PUT8(SDP_DATA_SEQ16, rsp);
-	SDP_PUT16(srv->fdidx[fd].rsp_size - 3, rsp);
+	ptr = rsp;
+	SDP_PUT8(SDP_DATA_SEQ16, ptr);
+	SDP_PUT16(srv->fdidx[fd].rsp_size - 3, ptr);
 
 	return (0);
 }
+
diff --git a/usr.sbin/sdpd/ssr.c b/usr.sbin/sdpd/ssr.c
index edde22a627..314cecbe24 100644
--- a/usr.sbin/sdpd/ssr.c
+++ b/usr.sbin/sdpd/ssr.c
@@ -1,6 +1,3 @@
-/* $NetBSD: ssr.c,v 1.2 2007/11/09 20:08:41 plunky Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/ssr.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * ssr.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: ssr.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/ssr.c,v 1.3 2005/01/05 18:37:37 emax Exp $
+ * $Id: ssr.c,v 1.5 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/ssr.c 139721 2005-01-05 18:37:37Z emax $
  */
 
 #include <sys/queue.h>
@@ -46,104 +43,6 @@
 #include "server.h"
 #include "uuid-private.h"
 
-/*
- * Extract ServiceSearchPattern from request to uuid array
- *	return count or 0 if error
- */
-int
-server_get_service_search_pattern(uint8_t const **buf, uint8_t const *end, uint128_t *uuid)
-{
-	uint8_t const *req = *buf;
-	uint32_t type, ssplen;
-	int count;
-
-	if (req + 1 > end)
-		return 0;
-
-	SDP_GET8(type, req);
-
-	ssplen = 0;
-	switch (type) {
-	case SDP_DATA_SEQ8:
-		if (req + 1 > end)
-			return 0;
-
-		SDP_GET8(ssplen, req);
-		break;
-
-	case SDP_DATA_SEQ16:
-		if (req + 2 > end)
-			return 0;
-
-		SDP_GET16(ssplen, req);
-		break;
-
-	case SDP_DATA_SEQ32:
-		if (req + 4 > end)
-			return 0;
-
-		SDP_GET32(ssplen, req);
-		break;
-
-	default:
-		return 0;
-	}
-
-	if (req + ssplen > end)
-		return 0;
-
-	count = 0;
-	while (ssplen > 0) {
-		if (count == 12)
-			return 0;
-
-		SDP_GET8(type, req);
-		ssplen--;
-
-		switch (type) {
-		case SDP_DATA_UUID16:
-			if (ssplen < 2)
-				return 0;
-
-			memcpy(uuid, &uuid_base, sizeof(*uuid));
-			uuid->b[2] = *req++;
-			uuid->b[3] = *req++;
-			ssplen -= 2;
-			break;
-
-		case SDP_DATA_UUID32:
-			if (ssplen < 4)
-				return 0;
-
-			memcpy(uuid, &uuid_base, sizeof(*uuid));
-			uuid->b[0] = *req++;
-			uuid->b[1] = *req++;
-			uuid->b[2] = *req++;
-			uuid->b[3] = *req++;
-			ssplen -= 4;
-			break;
-
-		case SDP_DATA_UUID128:
-			if (ssplen < 16)
-				return 0;
-
-			memcpy(uuid, req, 16);
-			req += 16;
-			ssplen -= 16;
-			break;
-
-		default:
-			return 0;
-		}
-
-		count++;
-		uuid++;
-	}
-
-	*buf = req;
-	return count;
-}
-
 /*
  * Prepare SDP Service Search Response
  */
@@ -154,11 +53,12 @@ server_prepare_service_search_response(server_p srv, int32_t fd)
 	uint8_t const	*req = srv->req + sizeof(sdp_pdu_t);
 	uint8_t const	*req_end = req + ((sdp_pdu_p)(srv->req))->len;
 	uint8_t		*rsp = srv->fdidx[fd].rsp;
-	uint8_t const	*rsp_end = rsp + L2CAP_MTU_MAXIMUM;
+	uint8_t const	*rsp_end = rsp + NG_L2CAP_MTU_MAXIMUM;
 
+	uint8_t		*ptr = NULL;
 	provider_t	*provider = NULL;
-	int32_t		 ucount, rsp_limit, cslen, cs;
-	uint128_t	 ulist[12];
+	int32_t		 type, ssplen, rsp_limit, rcount, cslen, cs;
+	uint128_t	 uuid, puuid;
 
 	/*
 	 * Minimal SDP Service Search Request
@@ -169,30 +69,50 @@ server_prepare_service_search_response(server_p srv, int32_t fd)
 	 * value8		- 1 byte  ContinuationState
 	 */
 
-	/* Get ServiceSearchPattern into uuid array */
-	ucount = server_get_service_search_pattern(&req, req_end, ulist);
-	if (ucount < 1 || ucount > 12)
+	if (req_end - req < 8)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
-	/* Get MaximumServiceRecordCount */
-	if (req + 2 > req_end)
+	/* Get size of ServiceSearchPattern */
+	ssplen = 0;
+	SDP_GET8(type, req);
+	switch (type) {
+	case SDP_DATA_SEQ8:
+		SDP_GET8(ssplen, req);
+		break;
+
+	case SDP_DATA_SEQ16:
+		SDP_GET16(ssplen, req);
+		break;
+
+	case SDP_DATA_SEQ32:
+		SDP_GET32(ssplen, req);
+		break;
+	}
+	if (ssplen <= 0)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
-	SDP_GET16(rsp_limit, req);
+	ptr = (uint8_t *) req + ssplen;
+
+	/* Get MaximumServiceRecordCount */
+	if (ptr + 2 > req_end)
+		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+	
+	SDP_GET16(rsp_limit, ptr);
 	if (rsp_limit <= 0)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
 	/* Get ContinuationState */
-	if (req + 1 > req_end)
+	if (ptr + 1 > req_end)
 		return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
-	SDP_GET8(cslen, req);
-	if (cslen == 2 && req + 2 == req_end)
-		SDP_GET16(cs, req);
-	else if (cslen == 0 && req == req_end)
+	SDP_GET8(cslen, ptr);
+	if (cslen != 0) {
+		if (cslen != 2 || req_end - ptr != 2)
+			return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
+		SDP_GET16(cs, ptr);
+	} else
 		cs = 0;
-	else
-		return (SDP_ERROR_CODE_INVALID_CONTINUATION_STATE);
 
 	/* Process the request. First, check continuation state */
 	if (srv->fdidx[fd].rsp_cs != cs)
@@ -207,27 +127,79 @@ server_prepare_service_search_response(server_p srv, int32_t fd)
 	 * value16	- 2 bytes CurrentServiceRecordCount (not incl.)
 	 * value32	- 4 bytes handle
 	 * [ value32 ]
+	 *
+	 * Calculate how many record handles we can fit 
+	 * in our reply buffer and adjust rlimit.
 	 */
 
-	/* Look for the record handles and add to the rsp buffer */
-	for (provider = provider_get_first();
-	     provider != NULL;
-	     provider = provider_get_next(provider)) {
-		if (!provider_match_bdaddr(provider, &srv->req_sa.bt_bdaddr))
-			continue;
+	ptr = rsp;
+	rcount = (rsp_end - ptr) / 4;
+	if (rcount < rsp_limit)
+		rsp_limit = rcount;
+
+	/* Look for the record handles */
+	for (rcount = 0; ssplen > 0 && rcount < rsp_limit; ) {
+		SDP_GET8(type, req);
+		ssplen --;
 
-		if (!provider_match_uuid(provider, ulist, ucount))
-			continue;
+		switch (type) {
+		case SDP_DATA_UUID16:
+			if (ssplen < 2)
+				return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
 
-		if (rsp + 4 > rsp_end)
+			memcpy(&uuid, &uuid_base, sizeof(uuid));
+			uuid.b[2] = *req ++;
+			uuid.b[3] = *req ++;
+			ssplen -= 2;
 			break;
 
-		SDP_PUT32(provider->handle, rsp);
+		case SDP_DATA_UUID32:
+			if (ssplen < 4)
+				return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
+			memcpy(&uuid, &uuid_base, sizeof(uuid));
+			uuid.b[0] = *req ++;
+			uuid.b[1] = *req ++;
+			uuid.b[2] = *req ++;
+			uuid.b[3] = *req ++;
+			ssplen -= 4;
+			break;
+
+		case SDP_DATA_UUID128:
+			if (ssplen < 16)
+				return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+
+			memcpy(uuid.b, req, 16);
+			req += 16;
+			ssplen -= 16; 
+			break;
+
+		default:
+			return (SDP_ERROR_CODE_INVALID_REQUEST_SYNTAX);
+			/* NOT REACHED */
+		}
+
+		for (provider = provider_get_first();
+		     provider != NULL && rcount < rsp_limit;
+		     provider = provider_get_next(provider)) {
+			if (!provider_match_bdaddr(provider, &srv->req_sa.l2cap_bdaddr))
+				continue;
+
+			memcpy(&puuid, &uuid_base, sizeof(puuid));
+			puuid.b[2] = provider->profile->uuid >> 8;
+			puuid.b[3] = provider->profile->uuid;
+
+			if (memcmp(&uuid, &puuid, sizeof(uuid)) == 0 ||
+			    memcmp(&uuid, &uuid_public_browse_group, sizeof(uuid)) == 0) {
+				SDP_PUT32(provider->handle, ptr);
+				rcount ++;
+			}
+		}
 	}
 
 	/* Set reply size (not counting PDU header and continuation state) */
 	srv->fdidx[fd].rsp_limit = srv->fdidx[fd].omtu - sizeof(sdp_pdu_t) - 4;
-	srv->fdidx[fd].rsp_size = rsp - srv->fdidx[fd].rsp;
+	srv->fdidx[fd].rsp_size = ptr - rsp;
 	srv->fdidx[fd].rsp_cs = 0;
 
 	return (0);
@@ -256,7 +228,7 @@ server_send_service_search_response(server_p srv, int32_t fd)
 	if (size + 1 > srv->fdidx[fd].rsp_limit) {
 		/*
 		 * We need to split out response. Add 3 more bytes for the
-		 * continuation state and move rsp_end and rsp_cs backwards.
+		 * continuation state and move rsp_end and rsp_cs backwards. 
 		 */
 
 		while ((rsp_end - rsp) + 3 > srv->fdidx[fd].rsp_limit) {
@@ -307,3 +279,4 @@ server_send_service_search_response(server_p srv, int32_t fd)
 
 	return ((size < 0)? errno : 0);
 }
+
diff --git a/usr.sbin/sdpd/sur.c b/usr.sbin/sdpd/sur.c
index 1d18660c6f..1cdd456f4a 100644
--- a/usr.sbin/sdpd/sur.c
+++ b/usr.sbin/sdpd/sur.c
@@ -1,6 +1,3 @@
-/* $NetBSD: sur.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/sur.c,v 1.2 2008/05/19 10:19:49 corecode Exp $ */
-
 /*
  * sur.c
  *
@@ -28,12 +25,11 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: sur.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/sur.c,v 1.2 2005/12/06 17:56:36 emax Exp $
+ * $Id: sur.c,v 1.1 2004/01/13 01:54:39 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/sur.c 153176 2005-12-06 17:56:36Z emax $
  */
 
 #include <sys/queue.h>
-#include <sys/select.h>
 #include <bluetooth.h>
 #include <errno.h>
 #include <sdp.h>
@@ -84,3 +80,4 @@ server_prepare_service_unregister_response(server_p srv, int32_t fd)
 
 	return (0);
 }
+
diff --git a/usr.sbin/sdpd/uuid-private.h b/usr.sbin/sdpd/uuid-private.h
index ca0daf7634..2f6fbe15ee 100644
--- a/usr.sbin/sdpd/uuid-private.h
+++ b/usr.sbin/sdpd/uuid-private.h
@@ -1,6 +1,3 @@
-/* $NetBSD: uuid-private.h,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/uuid-private.h,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * uuid-private.h
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: uuid-private.h,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/uuid-private.h,v 1.1 2005/01/05 18:37:37 emax Exp $
+ * $Id: uuid-private.h,v 1.1 2004/12/09 18:20:26 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/uuid-private.h 139721 2005-01-05 18:37:37Z emax $
  */
 
 #ifndef _UUID_PRIVATE_H_
@@ -39,3 +36,4 @@ extern	uint128_t	uuid_base;
 extern	uint128_t	uuid_public_browse_group;
 
 #endif /* ndef _UUID_PRIVATE_H_ */
+
diff --git a/usr.sbin/sdpd/uuid.c b/usr.sbin/sdpd/uuid.c
index 4c80f2eda7..e1de5af7d1 100644
--- a/usr.sbin/sdpd/uuid.c
+++ b/usr.sbin/sdpd/uuid.c
@@ -1,6 +1,3 @@
-/* $NetBSD: uuid.c,v 1.1 2006/06/19 15:44:56 gdamore Exp $ */
-/* $DragonFly: src/usr.sbin/sdpd/uuid.c,v 1.1 2008/01/06 21:51:30 hasso Exp $ */
-
 /*
  * uuid.c
  *
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: uuid.c,v 1.2 2007/11/30 07:39:37 griffin Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/sdpd/uuid.c,v 1.1 2005/01/05 18:37:37 emax Exp $
+ * $Id: uuid.c,v 1.1 2004/12/09 18:20:26 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpd/uuid.c 139721 2005-01-05 18:37:37Z emax $
  */
 
 #include <bluetooth.h>
@@ -56,3 +53,4 @@ uint128_t	uuid_public_browse_group = {
 		0x00, 0x80, 0x5f, 0x9b, 0x34, 0xfb
 	}
 };
+
-- 
2.26.1

